/* Process model C form file: cdpd_mes_channel_monitor.pr.c */
/* Portions of this file copyright 1992-2003 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
const char cdpd_mes_channel_monitor_pr_c [] = "MIL_3_Tfile_Hdr_ 100A 30A op_runsim 7 403E68AA 403E68AA 1 zeus saviol 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 90b 2                                                                                                                                                                                                                                                                                                                                                                                                             ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>



/* Header Block */

#define PKT_ARRVL (op_intrpt_type () == OPC_INTRPT_STRM	)
#define IDLE	1
#define BUSY	0
#define SINK_OUTSTRM 0
#define NIL		0

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int	                    		busy_idle;
	int	                    		decode;
	Stathandle	             		bis_stathandle;
	Stathandle	             		decode_stathandle;
	Stathandle	             		control_packets_count;
	int	                    		ctrl_pk_counter;
	Sbhandle	               		rsm_buf_ptr;
	Packet *	               		seg_ptr;
	Packet *	               		frm_ptr;
	char *	                 		fmt_name;
	} cdpd_mes_channel_monitor_state;

#define pr_state_ptr            		((cdpd_mes_channel_monitor_state*) (OP_SIM_CONTEXT_PTR->mod_state_ptr))
#define busy_idle               		pr_state_ptr->busy_idle
#define decode                  		pr_state_ptr->decode
#define bis_stathandle          		pr_state_ptr->bis_stathandle
#define decode_stathandle       		pr_state_ptr->decode_stathandle
#define control_packets_count   		pr_state_ptr->control_packets_count
#define ctrl_pk_counter         		pr_state_ptr->ctrl_pk_counter
#define rsm_buf_ptr             		pr_state_ptr->rsm_buf_ptr
#define seg_ptr                 		pr_state_ptr->seg_ptr
#define frm_ptr                 		pr_state_ptr->frm_ptr
#define fmt_name                		pr_state_ptr->fmt_name

/* These macro definitions will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#if defined (OPD_PARALLEL)
#  define FIN_PREAMBLE_DEC	cdpd_mes_channel_monitor_state *op_sv_ptr; OpT_Sim_Context * tcontext_ptr;
#  define FIN_PREAMBLE_CODE	\
		if (VosS_Mt_Perform_Lock) \
			VOS_THREAD_SPECIFIC_DATA_GET (VosI_Globals.simi_mt_context_data_key, tcontext_ptr, SimT_Context *); \
		else \
			tcontext_ptr = VosI_Globals.simi_sequential_context_ptr; \
		op_sv_ptr = ((cdpd_mes_channel_monitor_state *)(tcontext_ptr->mod_state_ptr));
#else
#  define FIN_PREAMBLE_DEC	cdpd_mes_channel_monitor_state *op_sv_ptr;
#  define FIN_PREAMBLE_CODE	op_sv_ptr = pr_state_ptr;
#endif


/* No Function Block */


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ };
#endif

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void cdpd_mes_channel_monitor (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype cdpd_mes_channel_monitor_init (int * init_block_ptr);
	VosT_Address cdpd_mes_channel_monitor_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype, int);
	void cdpd_mes_channel_monitor_diag (OP_SIM_CONTEXT_ARG_OPT);
	void cdpd_mes_channel_monitor_terminate (OP_SIM_CONTEXT_ARG_OPT);
	void cdpd_mes_channel_monitor_svar (void *, const char *, void **);


	VosT_Fun_Status Vos_Define_Object (VosT_Obtype * _op_obst_ptr, const char * _op_name, unsigned int _op_size, unsigned int _op_init_obs, unsigned int _op_inc_obs);
	VosT_Address Vos_Alloc_Object_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype _op_ob_hndl);
	VosT_Fun_Status Vos_Poolmem_Dealloc_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Address _op_ob_ptr);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
cdpd_mes_channel_monitor (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (cdpd_mes_channel_monitor ());
	if (1)
		{
		
		Packet*		frmptr;
		double		status;
		extern FILE *fp;
		int			comp_frm_cnt;


		FSM_ENTER ("cdpd_mes_channel_monitor")

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (0, "init", "cdpd_mes_channel_monitor [init enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [init enter execs]", state0_enter_exec)
				{
				bis_stathandle        = op_stat_reg ("Busy/Idle Status Flag", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				decode_stathandle     = op_stat_reg ("Decode Status Flag", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				control_packets_count = op_stat_reg ("control packets count", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				
				ctrl_pk_counter = 0;
				rsm_buf_ptr = op_sar_buf_create(OPC_SAR_BUF_TYPE_REASSEMBLY, OPC_SAR_BUF_OPT_FLUSH_AUTO);
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "init", "cdpd_mes_channel_monitor [init exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [init exit execs]", state0_exit_exec)
				{
				busy_idle=1;
				decode=1;
				}
				FSM_PROFILE_SECTION_OUT (state0_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, "idle", state1_enter_exec, "cdpd_mes_channel_monitor [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [idle enter execs]", state1_enter_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state1_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,"cdpd_mes_channel_monitor")


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, "idle", "cdpd_mes_channel_monitor [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [idle exit execs]", state1_exit_exec)
				{
				/* In the AMPS specification, IDLE is defined as a value of 1	*/
				/* and busy is defined as 0.  Here we simply monitor the busy	*/
				/* stat of the access channel receiver and set the bit as it	*/
				/* changes.  The mobiles will access this object attribute to	*/
				/* check the value.												*/
				}
				FSM_PROFILE_SECTION_OUT (state1_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [idle trans conditions]", state1_trans_conds)
			FSM_INIT_COND (PKT_ARRVL)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT (state1_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;, "PKT_ARRVL", "", "idle", "bis_set")
				FSM_CASE_TRANSIT (1, 1, state1_enter_exec, ;, "default", "", "idle", "idle")
				}
				/*---------------------------------------------------------*/



			/** state (bis_set) enter executives **/
			FSM_STATE_ENTER_FORCED (2, "bis_set", state2_enter_exec, "cdpd_mes_channel_monitor [bis_set enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [bis_set enter execs]", state2_enter_exec)
				{
				frmptr = op_pk_get (op_intrpt_strm ());
				
				ctrl_pk_counter++;
				op_stat_write (control_packets_count, ctrl_pk_counter);
				
				if (frmptr != NIL)
				{
					op_pk_nfd_get(frmptr, "MDLP Data", &seg_ptr);
				
					/* Extract busy/idle state. */
					op_pk_nfd_get (frmptr, "bis", &busy_idle);
					op_stat_write(bis_stathandle, busy_idle);
				
					/* Extract decode success state. */
					op_pk_nfd_get (frmptr, "decode", &decode);
					op_stat_write(decode_stathandle, decode);
					
					if (seg_ptr != NIL)
					{
						if (op_sar_pk_is_segment(seg_ptr))
						{
							op_sar_rsmbuf_seg_insert(rsm_buf_ptr, seg_ptr);
						}
						op_pk_destroy(frmptr);
						comp_frm_cnt = op_sar_rsmbuf_pk_count(rsm_buf_ptr);
						while (comp_frm_cnt > 0)
						{
							frm_ptr = op_sar_rsmbuf_pk_remove(rsm_buf_ptr);
				
				/* The following is two sets of if statments.
				Only use ONE.  It's used to distinguish between the delimiting
				flags and the frame content.  The first one works if the frame 
				types are not formated.  Else you end up with all data 
				destroyed. The alternate method (second if) is preferred.  
				However, due to unexplained (and uncorrectable) bus errors 
				with the use of strcmp (string compare) the first method MUST 
				be used if multiple M-ES is present until this problem is 
				resolved */
				
							if (op_pk_type(frm_ptr) == OPC_PACKET_TYPE_FORMATTED)
								op_pk_destroy(frm_ptr);
				
							
				/*			if (op_pk_type(frm_ptr)== OPC_PACKET_TYPE_FORMATTED)
							{
								op_pk_format_info_get(frm_ptr, OPC_PK_PROPERTY_FORMAT_NAME, &fmt_name);
				//				printf("ch mon fmt type is %s\n", &fmt_name);
								if (strcmp (&fmt_name, "cdpd_frm_flag_seq") == 0)// get rid of frame flag sequence
								{
				//					printf("ch mon destroyed cdpd_frm_flag_seq\n");
									op_pk_destroy(frm_ptr);
								}
						    }*/
							else
								op_pk_send(frm_ptr, SINK_OUTSTRM);
							comp_frm_cnt--;
						}
					}
				}
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			/** state (bis_set) exit executives **/
			FSM_STATE_EXIT_FORCED (2, "bis_set", "cdpd_mes_channel_monitor [bis_set exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_mes_channel_monitor [bis_set exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state2_exit_exec)


			/** state (bis_set) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;, "default", "", "bis_set", "idle")
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,"cdpd_mes_channel_monitor")
		}
	}




void
cdpd_mes_channel_monitor_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	/* No Diagnostic Block */
	}




void
cdpd_mes_channel_monitor_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__;
#endif

	FIN_MT (cdpd_mes_channel_monitor_terminate ())

	Vos_Poolmem_Dealloc_MT (OP_SIM_CONTEXT_THREAD_INDEX_COMMA pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in cdpd_mes_channel_monitor_svar function. */
#undef busy_idle
#undef decode
#undef bis_stathandle
#undef decode_stathandle
#undef control_packets_count
#undef ctrl_pk_counter
#undef rsm_buf_ptr
#undef seg_ptr
#undef frm_ptr
#undef fmt_name

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
cdpd_mes_channel_monitor_init (int * init_block_ptr)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (cdpd_mes_channel_monitor_init (init_block_ptr))

	Vos_Define_Object (&obtype, "proc state vars (cdpd_mes_channel_monitor)",
		sizeof (cdpd_mes_channel_monitor_state), 0, 20);
	*init_block_ptr = 0;

	FRET (obtype)
	}

VosT_Address
cdpd_mes_channel_monitor_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype obtype, int init_block)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	cdpd_mes_channel_monitor_state * ptr;
	FIN_MT (cdpd_mes_channel_monitor_alloc (obtype))

	ptr = (cdpd_mes_channel_monitor_state *)Vos_Alloc_Object_MT (VOS_THREAD_INDEX_COMMA obtype);
	if (ptr != OPC_NIL)
		ptr->_op_current_block = init_block;
	FRET ((VosT_Address)ptr)
	}



void
cdpd_mes_channel_monitor_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	cdpd_mes_channel_monitor_state		*prs_ptr;

	FIN_MT (cdpd_mes_channel_monitor_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (cdpd_mes_channel_monitor_state *)gen_ptr;

	if (strcmp ("busy_idle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->busy_idle);
		FOUT
		}
	if (strcmp ("decode" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->decode);
		FOUT
		}
	if (strcmp ("bis_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->bis_stathandle);
		FOUT
		}
	if (strcmp ("decode_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->decode_stathandle);
		FOUT
		}
	if (strcmp ("control_packets_count" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->control_packets_count);
		FOUT
		}
	if (strcmp ("ctrl_pk_counter" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->ctrl_pk_counter);
		FOUT
		}
	if (strcmp ("rsm_buf_ptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->rsm_buf_ptr);
		FOUT
		}
	if (strcmp ("seg_ptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->seg_ptr);
		FOUT
		}
	if (strcmp ("frm_ptr" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->frm_ptr);
		FOUT
		}
	if (strcmp ("fmt_name" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->fmt_name);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

