/* Process model C form file: cdpd_sink.pr.c */
/* Portions of this file copyright 1992-2003 by OPNET Technologies, Inc. */



/* This variable carries the header into the object file */
const char cdpd_sink_pr_c [] = "MIL_3_Tfile_Hdr_ 100A 30A op_runsim 7 403E68A3 403E68A3 1 zeus saviol 0 0 none none 0 0 none 0 0 0 0 0 0 0 0 90b 2                                                                                                                                                                                                                                                                                                                                                                                                             ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>



/* Header Block */


#define ARRIVAL         op_intrpt_type () == OPC_INTRPT_STRM

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(_op_last_line_passed) = __LINE__ - _op_block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(_op_last_line_passed) = 0; _op_block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	int	                    		counter;
	Stathandle	             		Stathandle_frame_count;
	int	                    		byte_size;
	Stathandle	             		byte_size_stathandle;
	} cdpd_sink_state;

#define pr_state_ptr            		((cdpd_sink_state*) (OP_SIM_CONTEXT_PTR->mod_state_ptr))
#define counter                 		pr_state_ptr->counter
#define Stathandle_frame_count  		pr_state_ptr->Stathandle_frame_count
#define byte_size               		pr_state_ptr->byte_size
#define byte_size_stathandle    		pr_state_ptr->byte_size_stathandle

/* These macro definitions will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE
#if defined (OPD_PARALLEL)
#  define FIN_PREAMBLE_DEC	cdpd_sink_state *op_sv_ptr; OpT_Sim_Context * tcontext_ptr;
#  define FIN_PREAMBLE_CODE	\
		if (VosS_Mt_Perform_Lock) \
			VOS_THREAD_SPECIFIC_DATA_GET (VosI_Globals.simi_mt_context_data_key, tcontext_ptr, SimT_Context *); \
		else \
			tcontext_ptr = VosI_Globals.simi_sequential_context_ptr; \
		op_sv_ptr = ((cdpd_sink_state *)(tcontext_ptr->mod_state_ptr));
#else
#  define FIN_PREAMBLE_DEC	cdpd_sink_state *op_sv_ptr;
#  define FIN_PREAMBLE_CODE	op_sv_ptr = pr_state_ptr;
#endif


/* No Function Block */


#if !defined (VOSD_NO_FIN)
enum { _op_block_origin = __LINE__ };
#endif

/* Undefine optional tracing in FIN/FOUT/FRET */
/* The FSM has its own tracing code and the other */
/* functions should not have any tracing.		  */
#undef FIN_TRACING
#define FIN_TRACING

#undef FOUTRET_TRACING
#define FOUTRET_TRACING

#if defined (__cplusplus)
extern "C" {
#endif
	void cdpd_sink (OP_SIM_CONTEXT_ARG_OPT);
	VosT_Obtype cdpd_sink_init (int * init_block_ptr);
	VosT_Address cdpd_sink_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype, int);
	void cdpd_sink_diag (OP_SIM_CONTEXT_ARG_OPT);
	void cdpd_sink_terminate (OP_SIM_CONTEXT_ARG_OPT);
	void cdpd_sink_svar (void *, const char *, void **);


	VosT_Fun_Status Vos_Define_Object (VosT_Obtype * _op_obst_ptr, const char * _op_name, unsigned int _op_size, unsigned int _op_init_obs, unsigned int _op_inc_obs);
	VosT_Address Vos_Alloc_Object_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype _op_ob_hndl);
	VosT_Fun_Status Vos_Poolmem_Dealloc_MT (VOS_THREAD_INDEX_ARG_COMMA VosT_Address _op_ob_ptr);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
cdpd_sink (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	FIN_MT (cdpd_sink ());
	if (1)
		{
		Packet* frmptr;


		FSM_ENTER ("cdpd_sink")

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (DISCARD) enter executives **/
			FSM_STATE_ENTER_FORCED (0, "DISCARD", state0_enter_exec, "cdpd_sink [DISCARD enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_sink [DISCARD enter execs]", state0_enter_exec)
				{
				counter++;
				op_stat_write(Stathandle_frame_count, counter);
				frmptr = op_pk_get(op_intrpt_strm());
				byte_size=op_pk_total_size_get(frmptr);
				op_stat_write(byte_size_stathandle, byte_size);
				op_pk_destroy (frmptr);
				
				//printf("Counter is equal to : %d", counter);
				}
				FSM_PROFILE_SECTION_OUT (state0_enter_exec)

			/** state (DISCARD) exit executives **/
			FSM_STATE_EXIT_FORCED (0, "DISCARD", "cdpd_sink [DISCARD exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_sink [DISCARD exit execs]", state0_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state0_exit_exec)


			/** state (DISCARD) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "DISCARD", "idle")
				/*---------------------------------------------------------*/



			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED_NOLABEL (1, "init", "cdpd_sink [init enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_sink [init enter execs]", state1_enter_exec)
				{
				counter=0;
				Stathandle_frame_count=op_stat_reg ("frame count", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				byte_size_stathandle = op_stat_reg ("byte size", OPC_STAT_INDEX_NONE, OPC_STAT_LOCAL);
				}
				FSM_PROFILE_SECTION_OUT (state1_enter_exec)

			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (1, "init", "cdpd_sink [init exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_sink [init exit execs]", state1_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state1_exit_exec)


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (2, state2_enter_exec, ;, "default", "", "init", "idle")
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (2, "idle", state2_enter_exec, "cdpd_sink [idle enter execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_sink [idle enter execs]", state2_enter_exec)
				{
				//printf("I am just waiting! \n");
				}
				FSM_PROFILE_SECTION_OUT (state2_enter_exec)

			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (5,"cdpd_sink")


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (2, "idle", "cdpd_sink [idle exit execs]")
				FSM_PROFILE_SECTION_IN ("cdpd_sink [idle exit execs]", state2_exit_exec)
				{
				}
				FSM_PROFILE_SECTION_OUT (state2_exit_exec)


			/** state (idle) transition processing **/
			FSM_PROFILE_SECTION_IN ("cdpd_sink [idle trans conditions]", state2_trans_conds)
			FSM_INIT_COND (ARRIVAL)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")
			FSM_PROFILE_SECTION_OUT (state2_trans_conds)

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 0, state0_enter_exec, ;, "ARRIVAL", "", "idle", "DISCARD")
				FSM_CASE_TRANSIT (1, 2, state2_enter_exec, ;, "default", "", "idle", "idle")
				}
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (1,"cdpd_sink")
		}
	}




void
cdpd_sink_diag (OP_SIM_CONTEXT_ARG_OPT)
	{
	/* No Diagnostic Block */
	}




void
cdpd_sink_terminate (OP_SIM_CONTEXT_ARG_OPT)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = __LINE__;
#endif

	FIN_MT (cdpd_sink_terminate ())

	Vos_Poolmem_Dealloc_MT (OP_SIM_CONTEXT_THREAD_INDEX_COMMA pr_state_ptr);

	FOUT
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in cdpd_sink_svar function. */
#undef counter
#undef Stathandle_frame_count
#undef byte_size
#undef byte_size_stathandle

#undef FIN_PREAMBLE_DEC
#undef FIN_PREAMBLE_CODE

#define FIN_PREAMBLE_DEC
#define FIN_PREAMBLE_CODE

VosT_Obtype
cdpd_sink_init (int * init_block_ptr)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	VosT_Obtype obtype = OPC_NIL;
	FIN_MT (cdpd_sink_init (init_block_ptr))

	Vos_Define_Object (&obtype, "proc state vars (cdpd_sink)",
		sizeof (cdpd_sink_state), 0, 20);
	*init_block_ptr = 2;

	FRET (obtype)
	}

VosT_Address
cdpd_sink_alloc (VOS_THREAD_INDEX_ARG_COMMA VosT_Obtype obtype, int init_block)
	{

#if !defined (VOSD_NO_FIN)
	int _op_block_origin = 0;
#endif
	cdpd_sink_state * ptr;
	FIN_MT (cdpd_sink_alloc (obtype))

	ptr = (cdpd_sink_state *)Vos_Alloc_Object_MT (VOS_THREAD_INDEX_COMMA obtype);
	if (ptr != OPC_NIL)
		ptr->_op_current_block = init_block;
	FRET ((VosT_Address)ptr)
	}



void
cdpd_sink_svar (void * gen_ptr, const char * var_name, void ** var_p_ptr)
	{
	cdpd_sink_state		*prs_ptr;

	FIN_MT (cdpd_sink_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (void *)OPC_NIL;
		FOUT
		}
	prs_ptr = (cdpd_sink_state *)gen_ptr;

	if (strcmp ("counter" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->counter);
		FOUT
		}
	if (strcmp ("Stathandle_frame_count" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->Stathandle_frame_count);
		FOUT
		}
	if (strcmp ("byte_size" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->byte_size);
		FOUT
		}
	if (strcmp ("byte_size_stathandle" , var_name) == 0)
		{
		*var_p_ptr = (void *) (&prs_ptr->byte_size_stathandle);
		FOUT
		}
	*var_p_ptr = (void *)OPC_NIL;

	FOUT
	}

